#include "kprintf.h"
#include "string.h"
#include "terminal.h"
#include "ctype.h"
#include "stdlib.h"

#include <stdarg.h>

static int print_flag(char flag, va_list ap)
{
	switch (flag) {
		case 'i':
			return terminal_writelong(va_arg(ap, int));
		case 'd':
			return terminal_writelong(va_arg(ap, int));
		case 'c':
			return terminal_putchar(va_arg(ap, int));
		case 's':
			return terminal_writestring(va_arg(ap, char *));
	}
	return 0;
}

int kvprintf(int level, const char *restrict format, va_list ap)
{
	const char *start = format;
	const char *flag;
	long padding;
	int ret = 0;

	while (*start != '\0') {
		flag = strchr(start, '%');
		if (flag != NULL) {
			padding = atoll(start + 1);
			for (; isdigit(*flag); flag++);
			ret += print_flag(*flag, ap);
			start = flag + 1;
		}
		else {
			terminal_writestring(start);
			start += strlen(start);
		}
	}
	return ret;
}